Main Page | Namespace List | Class Hierarchy | Alphabetical List | Compound List | File List | Namespace Members | Compound Members | File Members

# SHA256 Class Reference

`#include <sha.h>`

Inheritance diagram for SHA256:

List of all members.

## Detailed Description

implements the SHA-256 standard

Definition at line 24 of file sha.h.

## Public Types
enum | { DIGESTSIZE = 32 }
typedef BigEndian | ByteOrderClass
typedef IteratedHashBase< word32, HashTransformation >::HashWordType | HashWordType
## Public Member Functions
std::string | AlgorithmName () const
void | TruncatedFinal (byte *hash, unsigned int size)
| truncated version of Final()
unsigned int | DigestSize () const
unsigned int | OptimalBlockSize () const
void | Update (const byte *input, unsigned int length)
byte * | CreateUpdateSpace (unsigned int &size)
void | Restart ()
virtual void | Final (byte *digest)
| compute hash for current message, then restart for a new message
virtual void | CalculateDigest (byte *digest, const byte *input, unsigned int length)
| use this if your input is in one piece and you don't want to call Update() and Final() separately
virtual bool | Verify (const byte *digest)
| verify that digest is a valid digest for the current message, then reinitialize the object
virtual bool | VerifyDigest (const byte *digest, const byte *input, unsigned int length)
| use this if your input is in one piece and you don't want to call Update() and Verify() separately
virtual void | CalculateTruncatedDigest (byte *digest, unsigned int digestSize, const byte *input, unsigned int length)
| truncated version of CalculateDigest()
virtual bool | TruncatedVerify (const byte *digest, unsigned int digestLength)
| truncated version of Verify()
virtual bool | VerifyTruncatedDigest (const byte *digest, unsigned int digestLength, const byte *input, unsigned int length)
| truncated version of VerifyDigest()
virtual Clonable * | Clone () const
| this is not implemented by most classes yet
## Static Public Member Functions
void | Transform (word32 *digest, const word32 *data)
const char * | StaticAlgorithmName ()
void | CorrectEndianess (HashWordType *out, const HashWordType *in, unsigned int byteCount)
## Protected Member Functions
void | Init ()
void | vTransform (const word32 *data)
virtual void | vTransform (const HashWordType *data)=0
unsigned int | BlockSize () const
| block size of underlying compression function, or 0 if not block based
void | HashBlock (const HashWordType *input)
virtual void | HashBlock (const word32 *input)=0
word32 | GetBitCountHi () const
word32 | GetBitCountLo () const
virtual unsigned int | HashMultipleBlocks (const word32 *input, unsigned int length)
void | PadLastBlock (unsigned int lastBlockSize, byte padFirst=0x80)
void | ThrowIfInvalidTruncatedSize (unsigned int size) const
## Protected Attributes
SecBlock< word32 > | m_data
SecBlock< word32 > | m_digest
## Static Protected Attributes
const word32 | K [64]

## Member Function Documentation

virtual void HashTransformation::Final | ( | byte * | digest | ) | `[inline, virtual, inherited]`

| compute hash for current message, then restart for a new message Precondition: size of digest == DigestSize(). Reimplemented in PKCS_DecoratedHashModule< H >, SignatureEncodingMethodWithRecovery, and EMSA2DecoratedHashModule< H >. Definition at line 526 of file cryptlib.h. Referenced by HashFilter::Put2(), PK_SignerBase< H >::SignAndRestart(), and PK_VerifierBase< H >::VerifyAndRestart().

virtual bool HashTransformation::Verify | ( | const byte * | digest | ) | `[inline, virtual, inherited]`

| verify that digest is a valid digest for the current message, then reinitialize the object Default implementation is to call Final() and do a bitwise comparison between its output and digest. Reimplemented in SignatureEncodingMethodWithRecovery. Definition at line 549 of file cryptlib.h. Referenced by VerifierWithRecoveryTemplate< TF, H >::VerifyAndRestart().

## Member Data Documentation

const word32 SHA256::K`[static, protected]`

| Initial value:
     {
            0x428a2f98, 0x71374491, 0xb5c0fbcf, 0xe9b5dba5,
            0x3956c25b, 0x59f111f1, 0x923f82a4, 0xab1c5ed5,
            0xd807aa98, 0x12835b01, 0x243185be, 0x550c7dc3,
            0x72be5d74, 0x80deb1fe, 0x9bdc06a7, 0xc19bf174,
            0xe49b69c1, 0xefbe4786, 0x0fc19dc6, 0x240ca1cc,
            0x2de92c6f, 0x4a7484aa, 0x5cb0a9dc, 0x76f988da,
            0x983e5152, 0xa831c66d, 0xb00327c8, 0xbf597fc7,
            0xc6e00bf3, 0xd5a79147, 0x06ca6351, 0x14292967,
            0x27b70a85, 0x2e1b2138, 0x4d2c6dfc, 0x53380d13,
            0x650a7354, 0x766a0abb, 0x81c2c92e, 0x92722c85,
            0xa2bfe8a1, 0xa81a664b, 0xc24b8b70, 0xc76c51a3,
            0xd192e819, 0xd6990624, 0xf40e3585, 0x106aa070,
            0x19a4c116, 0x1e376c08, 0x2748774c, 0x34b0bcb5,
            0x391c0cb3, 0x4ed8aa4a, 0x5b9cca4f, 0x682e6ff3,
            0x748f82ee, 0x78a5636f, 0x84c87814, 0x8cc70208,
            0x90befffa, 0xa4506ceb, 0xbef9a3f7, 0xc67178f2
    }
Definition at line 150 of file sha.cpp.

The documentation for this class was generated from the following files:

- sha.h
- sha.cpp